; 
.nolist    
    include     masm32rt.inc    ; defaults to .386
.586
    include     timers.asm      ; requires a pentium
; 
    Ratch     proto   :DWORD
    RatchX     proto   :DWORD
    RatchX2     proto   :DWORD
    StrLen2     proto   :DWORD
; 
.data
align 16
    str0        db 0
align 16
    str1        db 'X',0
align 16
    str2        db 'XX',0
align 16
    str3        db 'XXX',0
align 16
    str4        db 'XXXX',0
align 16
    str5        db 'X',129,'XXX',0   ; was 'XXXXX',0
align 16
    str15       db 15 dup('X'),0
align 16
    str16       db 16 dup('X'),0
align 16
    str17       db 31 dup('X'),0
align 16
    str255      db 255 dup('X'),0
align 16
    str1023     db 1023 dup('X'),0
align 16
    hHnd        dd 0
    cPos        COORD<0,0>
.code
; 
start:
; 
    invoke GetStdHandle,STD_OUTPUT_HANDLE
    mov hHnd, eax
    mov al,1
    mov edx,offset str255
@@:
	mov [edx],al
	inc al
	inc edx
	cmp al,0
	jne @b
	
    cls
    invoke SetConsoleCursorPosition,hHnd,dword ptr cPos
    print chr$("Bytes")
    add [cPos.x],9
    invoke SetConsoleCursorPosition,hHnd,dword ptr cPos
    FOR teststr,<str0,str1,str2,str3,str4,str5,str15,str16,str17,str255,str1023>
        invoke RatchX,ADDR teststr
        print ustr$(eax)
        add [cPos.y],1
        invoke SetConsoleCursorPosition,hHnd,dword ptr cPos
        print chr$("=====")
        sub [cPos.y],1
        add [cPos.x],6
        invoke SetConsoleCursorPosition,hHnd,dword ptr cPos
    ENDM
    mov [cPos.x],0
    add [cPos.y],2
    invoke SetConsoleCursorPosition,hHnd,dword ptr cPos
    FOR testproc,<StrLen2,Ratch,RatchX,RatchX2>
    print chr$("&testproc&")
    add [cPos.x],9
    invoke SetConsoleCursorPosition,hHnd,dword ptr cPos
        FOR teststr,<str0,str1,str2,str3,str4,str5,str15,str16,str17,str255,str1023>
            counter_begin 1000000, HIGH_PRIORITY_CLASS
                invoke testproc,ADDR teststr
            counter_end
            print ustr$(eax)
            add [cPos.x],6      ; makes nice spacing
            invoke SetConsoleCursorPosition,hHnd,dword ptr cPos
            invoke Sleep,250    ; short break to let Windows stabilize
        ENDM
        mov [cPos.x],0          ; CR+LF
        inc [cPos.y]
        invoke SetConsoleCursorPosition,hHnd,dword ptr cPos
    ENDM
    mov   eax,input(13,10,"Press enter to exit...")
    exit
; 

.listall

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 16
Ratch proc junk:dword      ; from Ratch           ;it all begins here
 MOV EAX,[ESP+DWORD]       ;address of string

 .REPEAT                   ;searching string ....
   MOV EDX,[EAX]           ;next 4 byte gulp (DWORD)
   ADD EAX,DWORD           ;EAX=character pointer
   LEA ECX,[EDX-01010101H] ;propagate if byte is zero
   NOT EDX                 ;set up test pattern
   AND EDX,ECX             ;leftmost bit of zero byte should now be set
   AND EDX,080808080H      ;sieve out zero bytes
 .UNTIL !ZERO?             ;check the next DWORD

                           ;we now know the current DWORD contains a zero byte
 SUB EAX,DWORD+BYTE        ;compensate for entry additions into loops

 .REPEAT                   ;searching current DWORD ...
   INC EAX                 ;increase word count if no carry from shift
   ROR EDX,8               ;bring leftmost bit of each byte into carry flag
 .UNTIL CARRY?             ;if carry flag set, byte is zero

 SUB EAX,[ESP+DWORD]       ;subtract beginning of string to get length

 RET DWORD                 ;all done, and string length in EAX

Ratch endp

align 16
RatchX proc junk:dword      ; modified Ratch
	mov eax,[esp+4]   		;address of string
@@:		                    ;searching string ....
	mov edx,[eax]           ;next 4 byte gulp (DWORD)
	add eax,4               ;eax=character pointer to next dword to test
	lea ecx,[edx-01010101H] ;propagate if byte is zero
	not edx                 ;set up test pattern
	and edx,ecx             ;leftmost bit of zero byte should now be set
	and edx,080808080H      ;sieve out zero bytes
	jz @b  		            ;check the next DWORD
                            ;we now know the current DWORD contains a zero byte
	sub eax,4      			;compensate for entry additions into loops

@@:				           ;searching current DWORD ...
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
@@:
	sub eax,[esp+4]       ;subtract beginning of string to get length

	ret 4                 ;all done, and string length in EAX

RatchX endp

align 16
RatchX2 proc junk:dword      ; modified Ratch
	mov eax,[esp+4]   		;address of string
	nop
@@:		                    ;searching string ....
	mov edx,[eax]           ;next 4 byte gulp (DWORD)
	add eax,4               ;eax=character pointer to next dword to test
	lea ecx,[edx-01010101H] ;propagate if byte is zero
	not edx                 ;set up test pattern
	and edx,ecx             ;leftmost bit of zero byte should now be set
	and edx,080808080H      ;sieve out zero bytes
	jz @b  		            ;check the next DWORD
                            ;we now know the current DWORD contains a zero byte
	sub eax,4      			;compensate for entry additions into loops

@@:				           ;searching current DWORD ...
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
@@:
	sub eax,[esp+4]       ;subtract beginning of string to get length

	ret 4                 ;all done, and string length in EAX

RatchX2 endp

align 16

StrLen2 proc src:DWORD

    mov     ecx, [esp+1*4]
    test    ecx, 3
    jz      @max8

@bucle:
    mov     al, [ecx]
    add     ecx, 1
    test    al, al
    jz      @lb1

    test    ecx, 3
    jnz     @bucle
align 4
@max8:
    mov     eax, [ecx]
    mov     edx, 7EFEFEFFh
    add     edx, eax
    xor     eax, 0FFFFFFFFh
    xor     eax, edx
    add     ecx, 4
    test    eax, 81010100h
    jz      @max8

    mov     eax, [ecx-4]
    test    al, al
    jz      @lb4

    test    ah, ah
    jz      @lb3

    test    eax, 0FF0000h
    jz      @lb2

    test    eax, 0FF000000h
    jnz     @max8

@lb1:
    lea     eax, [ecx-1]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

@lb2:
    lea     eax, [ecx-2]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

@lb3:
    lea     eax, [ecx-3]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

@lb4:
    lea     eax, [ecx-4]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

StrLen2 endp

end start
